#-*- coding: utf-8 -*-

lib = File.expand_path('../lib', __FILE__)
$LOAD_PATH.unshift(lib) unless $LOAD_PATH.include?(lib)
require 'mmtrix/version'
require 'mmtrix/latest_changes'

Gem::Specification.new do |s|
  s.name = "mmtrix_rpm"
  s.version = Mmtrix::VERSION::STRING
  s.required_ruby_version = '>= 1.8.7'
  s.required_rubygems_version = Gem::Requirement.new("> 1.3.1") if s.respond_to? :required_rubygems_version=
  s.authors = [ "*****" ]
  s.date = Time.now.strftime('%Y-%m-%d')
  s.licenses    = ['Mmtrix', 'MIT', 'Ruby']
  s.description = <<-EOS
Mmtrix is a performance management system, developed by Mmtrix,
Inc (http://www.mmtrix.com).  Mmtrix provides you with deep
information about the performance of your web application as it runs
in production. The Mmtrix Ruby Agent is dual-purposed as a either a
Gem or plugin, hosted on
http://git.mmtrix.com/mmtrix/mmtrix_rpm
EOS
  s.email = "support@mmtrix.com"
  s.executables = [ "mongrel_rpm", "mmtrix_cmd", "mmtrix", "nrdebug" ]
  s.extra_rdoc_files = [
    "CHANGELOG",
    "LICENSE",
    "README.md",
    "GUIDELINES_FOR_CONTRIBUTING.md",
    "mmtrix.yml"
  ]

  file_list = `git ls-files`.split
  build_file_path = 'lib/mmtrix/build.rb'
  file_list << build_file_path if File.exist?(build_file_path)
  s.files = file_list

  s.homepage = "http://git.mmtrix.com/mmtrix/mmtrix_rpm/tree/master"
  s.require_paths = ["lib"]
  s.rubygems_version = Gem::VERSION
  s.summary = "Mmtrix Ruby Agent"

  s.add_development_dependency 'rake', '10.1.0'
  s.add_development_dependency 'minitest', '~> 4.7.5'
  s.add_development_dependency 'mocha', '~> 0.13.0'
  s.add_development_dependency 'yard'
  s.add_development_dependency 'rails', '~> 3.2.13'
  s.add_development_dependency 'pry', '~> 0.9.12'
  s.add_development_dependency 'hometown', '~> 0.2.5'

  # Only let Guard run on newer Rubies
  if RUBY_VERSION >= "1.9.3"
    s.add_development_dependency 'guard'
    s.add_development_dependency 'guard-minitest'
    s.add_development_dependency 'rb-fsevent'
  end

  # version lock down for i18n that is compatible with Ruby 1.8.7
  s.add_development_dependency 'i18n', '0.6.11'

  if RUBY_PLATFORM == 'java'
    s.add_development_dependency 'activerecord-jdbcsqlite3-adapter'
    s.add_development_dependency 'jruby-openssl'
  else
    s.add_development_dependency 'sqlite3'
  end

  if defined?(RUBY_ENGINE) && RUBY_ENGINE == 'rbx'
    s.add_development_dependency 'rubysl'
    s.add_development_dependency 'racc'
  end
end
