# encoding: utf-8
# This file is distributed under Mmtrix's license terms.


require File.expand_path(File.join(File.dirname(__FILE__),'..','..','..','test_helper'))
require 'mmtrix/agent/commands/agent_command'

module Mmtrix::Agent::Commands
  class AgentCommandTest < Minitest::Test
    ID = 123
    NAME = 'nuke_it_from_orbit'
    ARGUMENTS = { "profile_id" => 42 }

    NUKE_IT_FROM_ORBIT = [ID,{
      "name" => NAME,
      "arguments" => ARGUMENTS
    }]

    def test_destructures_name_from_collector_command
      command = AgentCommand.new(NUKE_IT_FROM_ORBIT)
      expected = NAME
      assert_equal expected, command.name
    end

    def test_destructures_id_from_collector_command
      command = AgentCommand.new(NUKE_IT_FROM_ORBIT)
      expected = ID
      assert_equal expected, command.id
    end

    def test_destructures_arguments_from_collector_command
      command = AgentCommand.new(NUKE_IT_FROM_ORBIT)
      expected = ARGUMENTS
      assert_equal expected, command.arguments
    end
  end
end
