# encoding: utf-8
# This file is distributed under Mmtrix's license terms.


require File.expand_path(File.join(File.dirname(__FILE__),'..','..','..','test_helper'))
require 'mmtrix/cli/command'
require 'mmtrix/cli/commands/install'

class Mmtrix::Cli::InstallTest < Minitest::Test
  def test_fails_without_app_name
    assert_raises(Mmtrix::Cli::Command::CommandFailure) do
      Mmtrix::Cli::Install.new(["-l", "license"])
    end
  end

  def test_basic_run
    install = Mmtrix::Cli::Install.new(["-l", "license", "app"])
    assert_equal "license", install.license_key
    assert_equal "app", install.app_name
  end

  def test_app_name_with_spaces
    install = Mmtrix::Cli::Install.new(["-l", "license", "my", "app"])
    assert_equal "license", install.license_key
    assert_equal "my app", install.app_name
  end
end
