# encoding: utf-8
# This file is distributed under Mmtrix's license terms.


require File.expand_path(File.join(File.dirname(__FILE__),'/../../../test_helper'))

class Mmtrix::Control::Frameworks::RailsTest < Minitest::Test
  def test_install_browser_monitoring
    require 'mmtrix/rack/browser_monitoring'
    middleware = stub('middleware config')
    config = stub('rails config', :middleware => middleware)
    middleware.expects(:use).with(Mmtrix::Rack::BrowserMonitoring)
    Mmtrix::Control.instance.instance_eval { @browser_monitoring_installed = false }
    with_config(:'browser_monitoring.auto_instrument' => true) do
      Mmtrix::Control.instance.install_browser_monitoring(config)
    end
  end

  def test_install_browser_monitoring_should_not_install_when_not_configured
    middleware = stub('middleware config')
    config = stub('rails config', :middleware => middleware)
    middleware.expects(:use).never
    Mmtrix::Control.instance.instance_eval { @browser_monitoring_installed = false }

    with_config(:'browser_monitoring.auto_instrument' => false) do
      Mmtrix::Control.instance.install_browser_monitoring(config)
    end
  end
end
