# encoding: utf-8
# This file is distributed under Mmtrix's license terms.


require 'rack'
require 'rack/request'
require 'fake_server'

module Mmtrix
  class FakeRpmSite < FakeServer
    def initialize(*_)
      super
      @requests = []
    end

    attr_reader :requests

    def call(env)
      @requests << unpack(env)
      [200, {}, ["Fine"]]
    end

    def unpack(env)
      ::Rack::Request.new(env).params
    end

    def reset
      @requests.clear
    end

    def app
      self
    end
  end
end
