# encoding: utf-8
# This file is distributed under Mmtrix's license terms.


require File.expand_path(File.join(File.dirname(__FILE__),'..','..','test_helper'))
require 'mmtrix/rack/agent_middleware'
require 'mmtrix/agent/transaction_state'

module Mmtrix
  module Rack
    class AgentMiddlewareTest < Minitest::Test
      class ExampleMiddleware < AgentMiddleware
        def traced_call(env)
          @app.call(env)
        end
      end

      attr_reader :middleware, :env

      def setup
        @app = lambda { |env| [200, {}, ['yeah!']]}
        @middleware = ExampleMiddleware.new(@app)
        @env = {}
      end

      def test_with_tracing_creates_a_transaction
        middleware.call(env)
        assert_metrics_recorded('Controller/Middleware/Rack/Mmtrix::Rack::AgentMiddlewareTest::ExampleMiddleware/call')
      end
    end
  end
end
