#!/usr/bin/ruby
# encoding: utf-8
# This file is distributed under Mmtrix's license terms.


ENV["MM_TRIX_LOG_FILE_PATH"] = "STDOUT"

# This file tries to require the minimum amount of the agent, and then call
# public API methods on it to ensure that they don't raise exceptions. It is
# expected to be called from a driver test which will check for failure in the
# status code and/or output.

require 'mmtrix/agent'

Mmtrix::Agent.record_metric("Custom/Record", 1)
Mmtrix::Agent.increment_metric("Custom/Increment", 1)

Mmtrix::Agent.require_test_helper
Mmtrix::Agent.add_instrumentation("*_foobar.rb")

Mmtrix::Agent.ignore_error_filter do
end

Mmtrix::Agent.notice_error(StandardError.new("Always an option"))

Mmtrix::Agent.record_custom_event(:DontStart, :dont => "even")

Mmtrix::Agent.ignore_transaction
Mmtrix::Agent.ignore_apdex
Mmtrix::Agent.ignore_enduser

Mmtrix::Agent.disable_all_tracing do
end

Mmtrix::Agent.disable_transaction_tracing do
end

Mmtrix::Agent.disable_sql_recording do
end

Mmtrix::Agent.set_transaction_name("Something/Different")
Mmtrix::Agent.get_transaction_name

Mmtrix::Agent.with_database_metric_name("Model", "Method") do
end

Mmtrix::Agent.set_sql_obfuscator do
end

Mmtrix::Agent.browser_timing_header
Mmtrix::Agent.browser_timing_footer

Mmtrix::Agent.add_custom_attributes(:custom => "attributes")
Mmtrix::Agent.add_custom_parameters(:custom => "parameters")
Mmtrix::Agent.add_request_parameters(:request => "parameters")
Mmtrix::Agent.set_user_attributes(:user => "attributes")

Mmtrix::Agent.get_stats("Foo/Bar")
Mmtrix::Agent.get_stats_no_scope("Foo/Bar")
Mmtrix::Agent.reset_stats
Mmtrix::Agent.drop_buffered_data

Mmtrix::Agent.abort_transaction!

Mmtrix::Agent.after_fork(options={})
Mmtrix::Agent.shutdown(options={})

Mmtrix::Agent::Deprecator.deprecate("SomeClass#old_method")
