# encoding: utf-8
# This file is distributed under Mmtrix's license terms.


require 'socket'

class ServiceTimeoutTest < Minitest::Test

  def setup
    hk = TCPServer.new('127.0.0.1',0)
    @port = hk.addr[1]

    Thread.new {
      client = hk.accept
      client.gets
      sleep 4
      client.close
      Thread.exit
    }
  end

  def teardown
    Mmtrix::Agent.config.reset_to_defaults
  end

  def test_service_timeout
    server = Mmtrix::Control::Server.new('localhost', @port)
    Mmtrix::Agent.config.add_config_for_testing(:timeout => 0.1)

    service = Mmtrix::Agent::MmtrixService.new('deadbeef', server)

    assert_raises Mmtrix::Agent::ServerConnectionException do
      service.send('send_request',
                   :uri => '/agent_listener/8/bd0e1d52adade840f7ca727d29a86249e89a6f1c/get_redirect_host',
                   :encoding => 'UTF-8', :collector => server, :data => 'blah')
    end
  end

end
