# encoding: utf-8
# This file is distributed under Mmtrix's license terms.


require 'mongo'
require 'mmtrix_rpm'
require 'mmtrix/agent/datastores/mongo'
require 'securerandom'

if Mmtrix::Agent::Datastores::Mongo.is_supported_version?
  require File.join(File.dirname(__FILE__), '..', '..', '..', 'helpers', 'mongo_metric_builder')
  require File.join(File.dirname(__FILE__), 'helpers', 'mongo_server')
  require File.join(File.dirname(__FILE__), 'helpers', 'mongo_replica_set')
  require File.join(File.dirname(__FILE__), 'helpers', 'mongo_operation_tests')

  class Mmtrix::Agent::Instrumentation::MongoConnectionTest
    include Mongo
    include ::Mmtrix::TestHelpers::MongoMetricBuilder
    include ::MongoOperationTests

    def setup
      @client = Mongo::Connection.new($mongo.host, $mongo.port)
      @database_name = "multiverse"
      @database = @client.db(@database_name)
      @collection_name = "tribbles-#{SecureRandom.hex(16)}"
      @collection = @database.collection(@collection_name)

      @tribble = {'name' => 'soterios johnson'}

      Mmtrix::Agent::Transaction.stubs(:recording_web_transaction?).returns(true)
      Mmtrix::Agent.drop_buffered_data
    end

    def teardown
      Mmtrix::Agent.drop_buffered_data
      @database.drop_collection(@collection_name)
    end
  end
end
