# encoding: utf-8
# This file is distributed under Mmtrix's license terms.


require File.join(File.dirname(__FILE__), '..', '..', '..', 'mmtrix', 'marshalling_test_cases')

if Mmtrix::LanguageSupport.can_fork?

class ResqueMarshallingTest < Minitest::Test

  include MultiverseHelpers
  include MarshallingTestCases

  setup_and_teardown_agent

  class DummyJob
    extend Resque::Plugins::MmtrixInstrumentation
  end

  def invoke_hook(name, *args)
    hooks = Array(Resque.send(name))
    hooks.each { |h| h.call(*args) }
  end

  def around_each
    invoke_hook(:before_first_fork)

    # We just need something that responds to object_id here, because our
    # Resque instrumentation uses that to assign a unique identifier to the pipe
    # that will be used to send data about this job.
    job = Object.new

    invoke_hook(:before_fork, job)

    child_pid = Process.fork

    if child_pid
      Process.wait(child_pid)
    else
      invoke_hook(:after_fork, job)
      DummyJob.around_perform_with_monitoring do
        yield
      end
      exit
    end
  end

  def after_each
    Mmtrix::Agent::PipeChannelManager.listener.stop
  end
end

end