# encoding: utf-8
# This file is distributed under Mmtrix's license terms.


class StatsHashPerfTest < Performance::TestCase
  def setup
    @hash = Mmtrix::Agent::StatsHash.new
    @specs = (1..100).map { |i| Mmtrix::MetricSpec.new("foo#{i}") }
  end

  def test_record
    measure do
      hash = Mmtrix::Agent::StatsHash.new
      @specs.each do |spec|
        hash.record(spec, 1)
      end
    end
  end

  def test_merge
    measure do
      incoming = Mmtrix::Agent::StatsHash.new
      @specs.each do |i|
        incoming.record(Mmtrix::MetricSpec.new("foo#{i}"), 1)
      end

      hash = Mmtrix::Agent::StatsHash.new
      hash.merge!(incoming)
    end
  end
end
